# Copyright 2006, Clemson University
# 
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions are met:
# 
#    1. Redistributions of source code must retain the above copyright 
# notice, this list of conditions and the following disclaimer.
#    2. Redistributions in binary form must reproduce the above copyright 
# notice, this list of conditions and the following disclaimer in the 
# documentation and/or other materials provided with the distribution.
#    3. The name of the author may not be used to endorse or promote 
# products derived from this software without specific prior written 
# permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
# DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.

WLANTraf instproc alloc-tcp {tcptype} {
    if {$tcptype != "Tahoe"} {
	set tcp [new Agent/TCP/$tcptype]

    } else {
	set tcp [new Agent/TCP]
    }
    return $tcp
}

WLANTraf instproc alloc-sink {delayed} {
    if {$delayed} {
	set sink [new Agent/TCPSink/DelAck]
    } else {
	set sink [new Agent/TCPSink]
    }
    return $sink
}

WLANTraf instproc setup-tcp {tcp sink client_app server_app fid client} {
    # set flow ID
    $tcp set fid_ $fid
    # register done procedure for when connection is closed
    $tcp proc done {} "$self done $tcp $sink $client_app $server_app $client"
}

# These need to be here so that we can attach the
# apps to a node (done in Tcl code)
WLANTraf instproc alloc-client-app {} {
    return [new Application/WLANTraf/Client]
}

WLANTraf instproc alloc-server-app {} {
    return [new Application/WLANTraf/Server]
}

WLANTraf instproc done {tcp sink client_app server_app client} {
    # the connection is done
    if {$client} {
	# if this is the client notifying that it's done, 
	# start the server
	$self start-server $server_app
    } else {
	# if this is the server notifying that it's done,
	# ask dump output
	$self server-done $server_app
	$self recycle $client_app
    }
#    delete $tcp
#    delete $sink
}

WLANTraf instproc now {} {
    set ns [Simulator instance]
    return [format "%.6f" [$ns now]]
}
